

#include <stdio.h>
#include <math.h>
#include <iostream.h>
#include "IFS.h"

extern BASIC_ERROR	gerror;
/*Only for image signals*/
Points<BYTE>	*normalise_signal(Points2D<double>	*signal,long	N)
{	
	double			SUM=0,SUM_synt=0,left_value,right_value,x,y,syntel;
	long			index,new_index,value;
	Points<BYTE>	*new_signal=new Points<BYTE>(N);
	if (gerror.error_occured())
		return(NULL);
	if (new_signal==NULL)
		{gerror.set(-1);return(NULL);}
	char			exact_match;
	
	new_index=0;
	left_value=new_index-0.5;
	right_value=new_index+0.5;
	index=1;
	signal->goto_first_point();
	exact_match=FALSE;
	while(index<=signal->total_points())
	{
		x=signal->pointx_value();
		y=signal->pointy_value();
		if (x==new_index)
		{
			signal->goto_next_point();
			index++;
			value=round(y);
			if (value>255)
				value=255;
			else if (value<0)
				value=0;
			new_signal->put_point(value);
			exact_match=TRUE;
		}
		else if ((x>=left_value)&&(x<right_value))
		{
			syntel=fabs(x-(double)new_index);
			SUM=SUM+syntel*y;
			SUM_synt+=syntel;
			signal->goto_next_point();
		}
		else
		{
			if (exact_match)
			{
				exact_match=FALSE;
				SUM=0;
				SUM_synt=0;
			}
			else
			{
				if (SUM_synt!=0)
				{
					y=SUM/SUM_synt;
					SUM=0;
					SUM_synt=0;
					value=round(y);
					if (value>255)
						value=255;
					else if (value<0)
						value=0;
					new_signal->put_point(value);
				}
				else
				{
					value=round(y);
					if (value>255)
						value=255;
					else if (value<0)
						value=0;
					new_signal->put_point(value);
				}
			}
			new_index++;
			left_value=new_index-0.5;
			right_value=new_index+0.5;
		}
	}
	return(new_signal);
}

//maps jth interval to ith section
Points2D<double>	*w_map_j_interval_to_i_section(Points<BYTE>	*plist,
												long	left_interval,
												long	right_interval,
												long	left_section,
												long	right_section,
												double	c_factor)
{
	Points2D<double>	*new_list;
	long	plist_index=plist->index_value(),i;
	double	x0,y0,xm,ym,xi1,yi1,xi,yi,a,b,c,f,wx,wy;
	
	plist->goto_index(left_interval);
	x0=plist->index_value();
	y0=plist->point_value();
	plist->goto_index(right_interval);
	xm=plist->index_value();
	ym=plist->point_value();
	plist->goto_index(left_section);
	xi1=plist->index_value();
	yi1=plist->point_value();
	plist->goto_index(right_section);
	xi=plist->index_value();
	yi=plist->point_value();
	
	a=(xi-xi1)/(xm-x0);
	//c=xi-a*xm;
	c=(xm*xi1-x0*xi)/(xm-x0);
	//b=(yi-yi1)/(xm-x0)+((ym-y0)/(xm-x0))*c_factor;
	b=(yi-yi1)/(xm-x0)-c_factor*(ym-y0)/(xm-x0);
	//f=yi-b*xm-c_factor*ym;
	f=(xm*yi1-x0*yi)/(xm-x0)-c_factor*(xm*y0-x0*ym)/(xm-x0);
	new_list=new Points2D<double>(right_interval-left_interval+1);
	if (gerror.error_occured())
		return(NULL);
	if (new_list==NULL)
		{gerror.set(-1);return(NULL);}
	plist->goto_index(left_section);
	wx=plist->index_value();
	wy=plist->point_value();
	new_list->put_point(wx,wy);
	plist->goto_index(left_interval+1);
	for (i=2;i<=right_interval-left_interval;i++)
	{
		wx=a*plist->index_value()+c;
		wy=b*plist->index_value()+c_factor*plist->point_value()+f;
		new_list->put_point(wx,wy);
		plist->goto_next_point();
	}
	plist->goto_index(right_section);
	wx=plist->index_value();
	wy=plist->point_value();
	new_list->put_point(wx,wy);
	/*Return to my index..*/
	plist->goto_index(plist_index);
	return(new_list);
}

Points<BYTE> *Quantisation_of_contraction_factors(Points<double>	*d,
												double	min,
												double 	max)
{
	Points<BYTE>	*qd=new Points<BYTE>(d->total_points());
	if (gerror.error_occured())
		return(NULL);
	if (qd==NULL)
		{gerror.set(-1);return(NULL);}
	long			i;
	double 			maxmin;
	
	d->goto_first_point();
	if (max!=min)
		maxmin=max-min;
	else
	{
		max=min+1;
		maxmin=1;
	}
	for(i=1;i<=d->total_points();i++)
	{
		qd->put_point(round(255*(d->point_value()-min)/(maxmin)));
		d->goto_next_point();
	}
	return qd;
}

Points<double> *DeQuantisation_of_contraction_factors(Points<BYTE>	*qd,
													double	min,
													double 	max)
{
	Points<double>	*d=new Points<double>(qd->total_points());
	double			temp;


	if (gerror.error_occured())
		return(NULL);
	if (d==NULL)
		{gerror.set(-1);return(NULL);}
	long			i;
	double maxmin;
	
	qd->goto_first_point();
	
	if (max!=min)
		maxmin=max-min;
	else
	{
		max=min+1;
		maxmin=1;
	}
	for(i=1;i<=qd->total_points();i++)
	{
		temp=qd->point_value()*maxmin/255+min;
		if (temp>=1.0)
			temp=0.95;
		d->put_point(temp);
		qd->goto_next_point();
	}
	return d;
}

Points<BYTE> *Quantisation_of_contraction_factors2(Points<double>	*d,
												double	min,
												double 	max)
{
	Points<BYTE>	*qd=new Points<BYTE>(d->total_points());
	if (gerror.error_occured())
		return(NULL);
	if (qd==NULL)
		{gerror.set(-1);return(NULL);}
	long			i;
	double 			MAX_VALUE=180;
	
	d->goto_first_point();
	for(i=1;i<=d->total_points();i++)
	{
		if (d->point_value()<=1)
			qd->put_point(round((d->point_value()-min)*MAX_VALUE/(1-min)));
		else
			qd->put_point(round((d->point_value()-1)*(255-MAX_VALUE)/(max-1)+MAX_VALUE));
		d->goto_next_point();
	}
	return qd;
}

Points<double> *DeQuantisation_of_contraction_factors2(Points<BYTE>	*qd,
													double	min,
													double 	max)
{
	Points<double>	*d=new Points<double>(qd->total_points());
	if (gerror.error_occured())
		return(NULL);
	if (d==NULL)
		{gerror.set(-1);return(NULL);}
	long			i;
	double MAX_VALUE=180;
	
	qd->goto_first_point();

	for(i=1;i<=qd->total_points();i++)
	{
		if (qd->point_value()<=MAX_VALUE)
			d->put_point(qd->point_value()*(1-min)/MAX_VALUE+min);
		else
			d->put_point((qd->point_value()-MAX_VALUE)*(max-1)/(255-MAX_VALUE)+1);
		qd->goto_next_point();
	}
	return d;
}