#ifndef __MEM__
#define __MEM__
#include <stdlib.h>
#ifndef __BASIC_ERROR__
	#include "basic_error.h"
#endif

#define		BYTE	unsigned char
#define		SBYTE	signed char
#define		int2	short
#define		int4	long
#define		int1	char
#define		uint1	unsigned char
#define		uint2	unsigned short
#define		uint4	unsigned long
#define		WORD	unsigned short

#define LOBYTE(w)           ((BYTE)(w))
#define HIBYTE(w)           ((BYTE)(((WORD)(w) >> 8) & 0xFF))
#ifndef TRUE
	#define TRUE	1
	#define	FALSE	0
#endif

extern float		Continuous_E;

#define		CONTINUOUS_COEFFICIENT				1.2
#define		DEBUG_INFO
#define		MY_MIN_DISTANCE_CONST				6
#define		MY_MAX_DISTANCE_CONST				14
#define		ERROR_DISTANCE						6
#define		BIG_ERROR_DISTANCE					35
#define		CONTINUOUS_DISTANCE					15
#define		SIZE_OF_BACK_UP_ALLOCATED_BLOCK		102400 /*100 KBYTES*/
#define		MINIMUM_BLOCK_NEEDED				2048   /*2 KBYTES*/
#define		BEEP_FREQ		0x250
#define		BEEP_DURATION	100


typedef		unsigned short			BYTE2;
typedef		unsigned long			BYTE4;
typedef enum{NOVERSION,
				v0_0,  /*Self Affine SA*/
				v1_0,	/*PSA*/
				v2_0,	/*improved PSA*/
				v2_1,
				v2D1_0,	/*PSA2D Square*/
				v2D2_0,	/*improved PSA2D Square*/
				v2D3_0,	/*PSA2D Triangle*/
				v2D4_0,	/*improved PSA2D Triangle*/
				v2D5_0,	/*Dynamic PSA2D Squares and squares*/
				v2D5_I,	/*Dynamic PSA2D Squares and squares*/
				v2D5_1,
				v2D6_0,	/*Biavariate*/
				v2D6_1,	/*Improved Bivariate*/
				v2D7_1,	/*Multilevel*/
				v2D9_0,	/*Dynamic PSA2D Bivariate Exponential Squares and squares*/
				v2D8_0,	/*X2 Y2*/
				v3D1_0	/*Dynamic Trivariate 3D model*/
	}	IFSversion;

typedef enum{geometric=0,
			analytic=1}	CONTRACTION_FACTORS_CALCULATION_TYPE;


typedef enum{	SA,
				PSA,
				iPSA,
				PSA2D_S,
				iPSA2D_S,
				PSA2D_T,
				iPSA2D_T,
				PSA2D_DS, /*Dynamic squares*/
				PSA2D_DIS, /*Dynamic Improved squares*/
				PSA2D_DS1_1,
				PSA2D_DBS, /*Dynamic Bivariate squares*/
				PSA2D_DIBS, /*Dynamic Exhaustive Bivariate squares*/
				PSA2D_MBS, /*Dynamic Multi Bivariate squares*/
				PSA2D_BEXPS /*Dynamic Bivariate Exponential Squares*/
}	COMPRESS_METHOD_TYPE;


typedef BYTE	BOOLEAN;


void		try_to_allocate_some_memory 	(void);
void 		initialize_memory 				(void);
void*		mymalloc 						(size_t	bytes);
void		myfree 							(void** pointer,size_t	bytes);
long		memory_available				(void);
BYTE		find_high_word					(long		long_value);
BYTE		find_low_word					(long		long_value);
void 		memory_failure 					(void);
void		check_for_emergency_memory	(void);

long		myround(float	number);
double		round(double	number);
long		round(float	number);
long		trunc(float	number);
float		sqr(float	x);
float		max4(float x1,float x2,float x3,float x4);
float		min4(float x1,float x2,float x3,float x4);
#endif
