
#include <math.h>
#include <stdio.h>
#include "mem.h"

extern BASIC_ERROR	gerror;
void*	gemergency_pointer=NULL;
char	low_memory_warning;

long	number_of_bytes_that_Basic_Shell_used;
long	number_of_bytes_that_Basic_Shell_throwed_away;


long	trunc(float	number)
{
	if (number>=0)
		if (number==(long)number)
			return (long)number;
		else
			return (long)number+1;
	else
		if (number==(long)number)
			return (long)number;
		else
			return (long)number-1;
}

long	round(float	number)
{
	long	pre_int,nex_int;

	if (number>=0)
	{
		pre_int=(long)number;
		nex_int=(long)number+1;
		if (number-pre_int<0.5)
			return pre_int;
		else
			return nex_int;
	}
	else
	{
		nex_int=(long)number;
		pre_int=(long)number-1;
		if (number-pre_int<0.5)
			return pre_int;
		else
			return nex_int;
	}
}



double	round(double number)
{
	double	pre_int,nex_int;

		pre_int=floor(number);
		nex_int=ceil(number);
		if (number-pre_int<0.5)
			return pre_int;
		else
			return nex_int;
}




/*****************************************************/
void	check_for_emergency_memory	(void)
{
	/*Put Here The Function..*/
	#ifdef	__MACOS__
	mac_check_for_emergency_memory();
	#endif
}

/*****************************************************/
void memory_failure (void)
{
	/*Put Here The Failure Function..*/
	#ifdef	__MACOS__
	mac_memory_failure();
	#endif
}

/**************************************************************************/
float	sqr(float	x)
{
	return(x*x);
}

/**************************************************************************/
BYTE		find_low_word  	(long		long_value)
{
	BYTE*		address1;
	BYTE		lowword;
	
	address1=(BYTE*)((long)(&long_value)+2);
	lowword=*address1;
	return(lowword);
}

/**************************************************************************/
BYTE		find_high_word		(long		long_value)
{
	BYTE*		address1;
	BYTE		highword;
	
	address1=(BYTE*)&long_value;
	highword=*address1;
	return(highword);
}


/**************************************************************************/
long		memory_available(void)
{
	long	memory=40960;
	long	x,a,b,x2,free_memory;
	void*	generic_pointer;
	void*	largest_unused_block;
	
	generic_pointer=malloc(1);
	if (generic_pointer==NULL)
		return(0);
	free(generic_pointer);
	
	while	( (generic_pointer=malloc(memory))!=NULL )
	{
		free(generic_pointer);
		memory*=2;
	}
	/*M */
	a=0;
	b=memory;
	
	while (a!=b)
	{
		x=(a+b)/2;
		if ( (generic_pointer=malloc(x))==NULL )
			b=x;
		else	a=x;
		free(generic_pointer);
		if (b-a==1)
			break;
	}
	if (b-a==1)
	{
		if ( (generic_pointer=malloc(b))==NULL )
			x=a;
		else	x=b;
		free(generic_pointer);
	}
	largest_unused_block=malloc(x);
	if ( (x2=memory_available())==0)
		free_memory=x;
	else
		free_memory=x+x2;
	free(largest_unused_block);
	return(free_memory);
}
/**************************************************************************/
void	try_to_allocate_some_memory (void)
{
	void*	temp_pointer;
	
	if (gemergency_pointer==NULL)
	{
		gemergency_pointer=malloc(SIZE_OF_BACK_UP_ALLOCATED_BLOCK);
		if (gemergency_pointer!=NULL)
		{
			temp_pointer=malloc(MINIMUM_BLOCK_NEEDED);
			if (temp_pointer==NULL)
				free(gemergency_pointer);
			if (low_memory_warning==true)
				low_memory_warning=false;
		}
		else
		{
			temp_pointer=malloc(MINIMUM_BLOCK_NEEDED);
			if (temp_pointer==NULL)
				if (low_memory_warning==false)
					low_memory_warning=true;
			else
				if (low_memory_warning==true)
					low_memory_warning=false;
			free(temp_pointer);
		}
	}
}
/*************************************************************************/
void	myfree (void** pointer_address,size_t	bytes)
{
	void*	pointer;

	pointer=*pointer_address;
	if (pointer!=NULL)
	{
		free(pointer);
		*pointer_address=NULL;
		/*For Debugging Reasons*/
		number_of_bytes_that_Basic_Shell_throwed_away+=bytes;
		/*******************************/
	}
	check_for_emergency_memory();
}


/*************************************************************************/
void*	mymalloc (size_t	bytes)
{
	void*	pointer;
	
	if (bytes>0){
		pointer=malloc(bytes);
		if (pointer==NULL)
		{
			memory_failure();
			pointer=malloc(bytes);
			if (pointer==NULL)
				{gerror.set(-1);
				printf("Out of memory %ld bytes requested", bytes);
				exit(-1);}
		}
		/*For Debugging Reasons*/
		number_of_bytes_that_Basic_Shell_used+=bytes;
		/*******************************/
		return(pointer);
	}
	else
		return NULL;
}



/*************************************************************************/
void initialize_memory (void)
{
	void*	temp_pointer;
	
	/*For Debugging Reasons*/
	number_of_bytes_that_Basic_Shell_used=0;
	number_of_bytes_that_Basic_Shell_throwed_away=0;
	/***********************************************/
	
	gemergency_pointer=malloc(SIZE_OF_BACK_UP_ALLOCATED_BLOCK);
	if (gemergency_pointer==NULL)
	{
		temp_pointer=malloc(MINIMUM_BLOCK_NEEDED);
		if (temp_pointer==NULL)
			low_memory_warning=true;
		else
			low_memory_warning=false;
		free(temp_pointer);
	}
	else
	{	/*A    2 kbytes     20*/
		low_memory_warning=false;
		temp_pointer=malloc(MINIMUM_BLOCK_NEEDED);
		if (temp_pointer==NULL)
			free(gemergency_pointer);
		free(temp_pointer);
	}
}

long		myround(float	number)
{
	long	akeraio_meros;
	
	akeraio_meros=(long)number;
	if (number-akeraio_meros<=0.5)
		return akeraio_meros;
	else
		return akeraio_meros+1;
}

float		max4(float x1,float x2,float x3,float x4)
{
	float	max;
	
	max=x1;
	if (x2>max)
		max=x2;
	if (x3>max)
		max=x3;
	if (x4>max)
		max=x4;
	
	return max;
}

float		min4(float x1,float x2,float x3,float x4)
{
	float	min;
	
	min=x1;
	if (x2<min)
		min=x2;
	if (x3<min)
		min=x3;
	if (x4<min)
		min=x4;
	
	return min;

}


/*
//modulous operator. b!=0
double		operator% (double a, double b)
{
	double	division=a/b;
	double	int_div=floor(division);

	return myround((division-int_div)*b);
}
*/