#ifndef __MYPOINTS__
#define	__MYPOINTS__

#ifndef __MEM__
#include "mem.h"
#endif

#ifndef gerror
	extern BASIC_ERROR	gerror;
#endif

template	<class Type>
class Points
{
	protected:
		unsigned long		index;	//index 1...N
		Type				x;	//value of point currently used
		unsigned long		N;	//total_points
		unsigned long		used;	//used points (rest is 0)
		Type				*address;	//buffer address
		Type				*index_pointer;
		
	public:
					Points(unsigned long number_of_points);
					Points();
					~Points();
		Type		*return_address(void);
		Type		*return_index_pointer(void);
		void		goto_next_point(void);
		void		goto_previous_point(void);
		void		goto_first_point(void);
		void		goto_index(unsigned long	index_value);
		void		move_points(unsigned long	i);
		void		set_used(unsigned long used_value);
		unsigned long		index_value(void);
		Type		point_value(void);
		Type		point_value(unsigned long);
		Type		read_point_value(unsigned int index_value);
		void		quicksort(void);
		unsigned long		how_many_points(void);
		unsigned long		total_points(void);
		BOOLEAN			put_point(Type value);
		void		print_points(void);
		void		set_point(Type value);
		void		increase_point(Type value);
		void		clear_points(void);//sets all points to (0,0)
		double		square_sum(void);
		double		sum(void);
		Type		find_max();
		Type		find_min();
		BOOLEAN		change_size(unsigned long	N1);
		BOOLEAN		write_to_file(FILE*);
		BOOLEAN		write_to_textfile(FILE*);
		//operators
		Points<Type>&		operator +=(Points<Type>& poin2);
		Points<Type>&		operator +=(Type point);
		Points<Type>&		operator -=(Points<Type>& poin2);
		Points<Type>&		operator -=(Type point);
		Points<Type>&		operator =(Points<Type>& poin2);
};



template	<class Type>
class SpecialPoints : public Points<Type>
{
	protected:
		signed char			*address2;	//buffer address (how many points)
		signed char			*index_pointer2;

	public:
					SpecialPoints(unsigned long number_of_points);
					SpecialPoints();
					~SpecialPoints();
		void		goto_next_point(void);
		void		goto_previous_point(void);
		void		goto_first_point(void);
		void		goto_index(unsigned long	index_value);
		void		move_points(unsigned long	i);
		void		quicksort(void);
		BOOLEAN		put_point(Type value);
		void		print_points(void);
		void		set_point(Type value);
		void		special_set_point(Type value);
		void		increase_point(Type value);
		void		clear_points(void);//sets all points to (0,0)
		BOOLEAN		change_size(unsigned long	N1);
		BOOLEAN		write_to_file(FILE*);
		BOOLEAN		write_to_textfile(FILE*);
		void		normalise();
		void		fill_with_zeros();
};


template	<class Type>
class Points2D
{
	private:
		unsigned long		index;	//index of point
		Type	x;	//value x of point currently used
		Type	y;	//value y of point currently used
		unsigned long		N;	//total_points
		unsigned long		used;	//used points (rest is 0)
		Type	*address;	//buffer address
		Type	*index_pointer;
		
	public:
					Points2D(unsigned long	number_of_points);
					Points2D(void);
					~Points2D();
		Type		*return_address();
		Type		*return_index_pointer();
		void		goto_next_point(void);
		void		goto_first_point(void);
		void		goto_index(unsigned long	index_value);
		void		move_i_points(unsigned long	i);
		void		set_used(unsigned long used_value);
		void		set_N(unsigned long N_value);//Be Carefull with this!!!
		unsigned long		index_value(void);
		Type		pointx_value(void);
		Type		pointy_value(void);
		Type		pointx_value(uint4);
		Type		pointy_value(uint4);
		void		setx_value(Type	xvalue);
		void		sety_value(Type yvalue);
		unsigned long		findx_value_index(Type x_value);
		void		quicksort(void);	//not ready
		unsigned long		how_many_points(void);
		unsigned long		total_points(void);
		int			put_point(Type xvalue,Type yvalue);
		void		print_points(void);
		void		set_point(unsigned long index_value,Type xvalue,Type yvalue);
		void		set_point2(Type xvalue1,Type xvalue,Type yvalue);
		void		clear_points(void);//sets all points to (0,0)
		void		change_size(unsigned long	N1); //not ready
		double		square_ysum(void);
		double		ysum(void);
		BOOLEAN		write_to_textfile(FILE*);
};

template	<class Type>
class Points3D
{
	private:
		unsigned long		index;	//index of point
		Type	x;	//value x of point currently used
		Type	y;	//value y of point currently used
		Type	z;	//value z of point currently used
		unsigned long		N;	//total_points
		unsigned long		used;	//used points (rest is 0)
		Type	*address;	//buffer address
		Type	*index_pointer;
		
	public:
					Points3D(unsigned long	number_of_points);
					Points3D(void);
					~Points3D();
		Type		*return_address();
		Type		*return_index_pointer();
		void		goto_next_point(void);
		void		goto_first_point(void);
		void		goto_index(unsigned long	index_value);
		void		move_i_points(unsigned long	i);
		void		set_used(unsigned long used_value);
		void		set_N(unsigned long N_value);//Be Carefull with this!!!
		unsigned long		index_value(void);
		Type		pointx_value(void);
		Type		pointy_value(void);
		Type		pointz_value(void);
		Type		pointx_value(int);
		Type		pointy_value(int);
		Type		pointz_value(int);
		void		setx_value(Type	xvalue);
		void		sety_value(Type yvalue);
		void		setz_value(Type zvalue);
		unsigned long		findxy_value_index(Type x_value,Type y_value);
		void		quicksort(void);	//not ready
		unsigned long		how_many_points(void);
		unsigned long		total_points(void);
		int			put_point(Type xvalue,Type yvalue,Type zvalue);
		void		print_points(void);
		void		set_point(unsigned long index_value,Type xvalue,Type yvalue,Type zvalue);
		void		clear_points(void);//sets all points to (0,0)
		void		change_size(unsigned long	N1); //not ready
		double		sumx(void);
		double		sumx2(void);
		double		sumy(void);
		double		sumy2(void);
		double		sumz(void);
		double		meanz(void);
		double		sumz2(void);
		double		sumxy(void);
		void		swap(Type *pointer1, Type *pointer2);
		void		swap(unsigned long	i1, unsigned long	i2);
		void		find_param_LSM(float &a, float &b, float &c);
		void		find_param_LSM2(float a, float b, float &c);
		void		remove_far_away_from_LSML_points(float	e);
		void		remove_far_away_from_LSML_points2(float	e,float a,float b);
		uint4		mean_square_distances_from_line(float a, float b, float c);
};


template <>
BOOLEAN		Points<float>::write_to_textfile(FILE*	stream);
template <>
BOOLEAN		Points<int>::write_to_textfile(FILE*	stream);
template <>
BOOLEAN		Points<long>::write_to_textfile(FILE*	stream);

template <>
BOOLEAN		SpecialPoints<float>::write_to_textfile(FILE*	stream);

template <>
BOOLEAN		SpecialPoints<int>::write_to_textfile(FILE*	stream);

template <>
BOOLEAN		SpecialPoints<long>::write_to_textfile(FILE*	stream);

//*****************************************************************
//Functions of Points class
//operators
//operators
//Be carefull when using them.
//All images involved must have the same size.
template <class Type>
Points<Type>&	Points<Type>::operator +=(Points<Type>& poin2)
{
	long	i,N=total_points();
	for (i=1;i<=N;i++){
		goto_index(i);
		increase_point(poin2.point_value(i));
	}
	return *this;
}


template <class Type>
Points<Type>&	Points<Type>::operator +=(Type poin2)
{
	long	i,N=total_points();
	for (i=1;i<=N;i++){
		goto_index(i);
		increase_point(poin2);
	}
	return *this;
}

template <class Type>
Points<Type>&	Points<Type>::operator -=(Points<Type>& pic2)
{
	long	i,N=total_points();
	for (i=1;i<=N;i++){
		goto_index(i);
		increase_point(-poin2.point_value(i));
	}
	return *this;
}

template <class Type>
Points<Type>&	Points<Type>::operator -=(Type poin2)
{
	long	i,N=total_points();
	for (i=1;i<=N;i++){
		goto_index(i);
		increase_point(-poin2);
	}
	return *this;
}

template <class Type>
Points<Type>&	Points<Type>::operator=(Points<Type>& poin2)
{
	long	i,N=total_points();
	for (i=1;i<=N;i++){
		goto_index(i);
		set_point(poin2.point_value(i));
	}
	return *this;
}


template <class Type>
Points<Type>::Points(unsigned long number_of_points)
{
	N=number_of_points;
	used=0;
	index=0;
	x=0;
	if (N>0)
		address=(Type *)mymalloc(N*sizeof(Type));
	else address=NULL;
	if (gerror.error_occured())
		return;
	index_pointer=address;
	#ifdef __DEBUG__
		cout << "Points allocated" << "\n" ;
	#endif
	
}

template <class Type>
Points<Type>::Points(void)
{
	N=0;
	used=0;
	index=0;
	x=0;
	address=NULL;
	index_pointer=address;
	#ifdef __DEBUG__
		cout << "Points allocated" << "\n" ;
	#endif
}

template <class Type>
Points<Type>::~Points()
{
	if (this!=NULL)
	{
		void*	temp;
		temp=address;
		if (address!=NULL)
			myfree(&temp,N*sizeof(Type));
		#ifdef __DEBUG__
			cout << "Points deallocated" << "\n" ;
		#endif
	}
}

template <class Type>
Type	*Points<Type>::return_address(void)
{
	return(address);
}

template <class Type>
Type	*Points<Type>::return_index_pointer()
{
	return(index_pointer);
}

template <class Type>
void		Points<Type>::goto_next_point(void)
{
	if (index<N)
	{
		index_pointer++;
		index++;
		x=*index_pointer;
	}
}

template <class Type>
void		Points<Type>::goto_previous_point(void)
{
	if (index>1)
	{
		index_pointer--;
		index--;
		x=*index_pointer;
	}
}


template <class Type>
void		Points<Type>::goto_first_point(void)
{
	if (N!=0)
	{
		index_pointer=address;
		index=1;
		x=*index_pointer;
	}
}

template <class Type>
void		Points<Type>::goto_index(unsigned long	index_value)
{
	if ((index_value<=N)&&(index_value>=1))
	{
		index_pointer=address+index_value-1;
		index=index_value;
		x=*index_pointer;
	}
}

template <class Type>
void		Points<Type>::move_points(unsigned long	i)
{
	index=index+i;
	if (index<=N)
	{
		index_pointer+=i;
		x=*index_pointer;
	}
	else
		index-=i;
}

template <class Type>
void		Points<Type>::set_used(unsigned long used_value)
{
	if (used_value>N)
		used=N;
	else
		used=used_value;
}

template <class Type>
unsigned long	Points<Type>::index_value(void)
{
	return(index);
}

template <class Type>
Type	Points<Type>::point_value(void)
{
	return(x);
}

template <class Type>
Type	Points<Type>::point_value(unsigned long	index_value)
{
	Type		*pointer;
	
	if ((index_value<=N)&&(index_value>=1))
	{
		pointer=address+index_value-1;
		return	*pointer;
	}
	else{
		pointer=address;
		return	*pointer;
	}
}

template <class Type>
Type	Points<Type>::read_point_value(unsigned int index_value)
{
	float	*pointer;
	
	pointer=address+index_value-1;
	return(*pointer);
}

template <class Type>
void		Points<Type>::quicksort(void)
{
	;
}

template <class Type>
unsigned long		Points<Type>::how_many_points(void)
{
	return(used);
}

template <class Type>
unsigned long		Points<Type>::total_points(void)
{
	return(N);
}

template <class Type>
BOOLEAN		Points<Type>::put_point(Type value)
{
	Type	*pointer;
	if (used<N)
	{
		pointer=address+used;
		used++;
		*pointer=value;
		return(TRUE);
	}
	else{ /*extend the size of memory*/
		if (!change_size(ceil(N*1.5+1)))
			return(FALSE);
		pointer=address+used;
		used++;
		*pointer=value;
		return(TRUE);
	}
}

template <class Type>
void		Points<Type>::print_points(void)
{
	unsigned long		i;
	Type	*pointer;	
	
	pointer=address;
	cout << "Printing Points:\n" << "N="<<N<<"\nused="<<used;
	cout<< "\n   x   \n";
	for (i=1;i<=used;i++)
	{
		cout << *(pointer++) << "  \n" ;
	}
}

template <class Type>
void		Points<Type>::set_point(Type value)
{
	*index_pointer=value;
	/*if (value>=255)
		*index_pointer=255;
	if (value<=0)
		*index_pointer=0;*/
}

template <class Type>
void		Points<Type>::increase_point(Type value)
{
	*index_pointer+=value;
}

template <class Type>
void		Points<Type>::clear_points(void)//sets all points to (0,0)
{
	Type	*pointer;
	unsigned long		i;
	
	pointer=address;
	for (i=1;i<=used;i++)
	{
		*(pointer++)=0;
	}
	used=0;
	x=0;
}

template <class Type>
double		Points<Type>::square_sum(void)
{
	Type	*pointer;
	unsigned long	i;
	float	sum=0;
	
	pointer=address;
	for (i=1;i<=N;i++)
	{
		sum+=sqr(*pointer);
		pointer++;
	}
	return(sum);
}

template <class Type>
double		Points<Type>::sum(void)
{
	Type	*pointer;
	unsigned long	i;
	float	sum=0;
	
	pointer=address;
	for (i=1;i<=N;i++)
	{
		sum+=(*pointer);
		pointer++;
	}
	return(sum);
}

template <class Type>
Type		Points<Type>::find_max()
{
	unsigned long	i;
	Type	max;
	Type	*pointer;
	
	pointer=address;
	max=*pointer;
	for(i=2;i<=used;i++)
	{
		pointer++;
		if (*pointer>max)
			max=*pointer;
	}
	return(max);
}


template <class Type>
Type		Points<Type>::find_min()
{
	unsigned long	i;
	Type	min;
	Type	*pointer;
	
	pointer=address;
	min=*pointer;
	for(i=2;i<=used;i++)
	{
		pointer++;
		if (*pointer<min)
			min=*pointer;
	}
	return(min);
}


template <class Type>
BOOLEAN		Points<Type>::change_size(unsigned long	N1)
{
	long		response,i;
	Type*		address2,*first;
	void		*temp_address;

	/*write all points to disk.*/
	address2=(Type *)mymalloc(N1*sizeof(Type));
	if (address2==NULL)
		exit(-1);
	temp_address=address;
	first=address2;
	for (i=1;i<=N;i++)
		*(address2++)=*(address++);
	used=N;
	N=N1;
	myfree(&temp_address,N);
	address=first;
	return(TRUE);
}

template <class Type>
BOOLEAN		Points<Type>::write_to_file(FILE*	stream)
{
	if (fwrite(address,sizeof(Type),used,stream)==used)
		return TRUE;
	else 
		return FALSE;
}

/*
template <class Type>
BOOLEAN		Points<Type>::write_to_textfile(FILE*	stream)
{
	unsigned long		i;
	
	for (i=0;i<used;i++){
		fprintf(stream,"%d point : %d\n",i,point_value(i));
		fprintf(stream,"%d point : %f\n",i,point_value(i));
	}
	return TRUE;
}*/


//*****************************************************************
//Functions of SpecialPoints class
template <class Type>
SpecialPoints<Type>::SpecialPoints(unsigned long number_of_points)
{
	N=number_of_points;
	used=0;
	index=0;
	x=0;
	if (N>0){
		address=(Type *)mymalloc(N*sizeof(Type));
		address2=(signed char *)mymalloc(N*sizeof(signed char));}
	else{
		address=NULL;
		address2=NULL;}
	if (gerror.error_occured())
		return;
	index_pointer=address;
	index_pointer2=address2;
	#ifdef __DEBUG__
		cout << "SpecialPoints allocated" << "\n" ;
	#endif
	
}

template <class Type>
SpecialPoints<Type>::SpecialPoints(void)
{
	N=0;
	used=0;
	index=0;
	x=0;
	address=NULL;
	address2=NULL;
	index_pointer=address;
	index_pointer2=address2;
	#ifdef __DEBUG__
		cout << "SpecialPoints allocated" << "\n" ;
	#endif
}

template <class Type>
SpecialPoints<Type>::~SpecialPoints()
{
	if (this!=NULL)
	{
		void*	temp=address2;
		if (address2!=NULL)
			myfree(&temp,N*sizeof(signed char));
		#ifdef __DEBUG__
			cout << "Points deallocated" << "\n" ;
		#endif
	}
}


template <class Type>
void		SpecialPoints<Type>::goto_next_point(void)
{
	if (index<N)
	{
		index_pointer++;
		index++;
		index_pointer2++;
		x=*index_pointer;
	}
}

template <class Type>
void		SpecialPoints<Type>::goto_previous_point(void)
{
	if (index>1)
	{
		index_pointer--;
		index_pointer2--;
		index--;
		x=*index_pointer;
	}
}


template <class Type>
void		SpecialPoints<Type>::goto_first_point(void)
{
	if (N!=0)
	{
		index_pointer=address;
		index_pointer2=address2;
		index=1;
		x=*index_pointer;
	}
}

template <class Type>
void		SpecialPoints<Type>::goto_index(unsigned long	index_value)
{
	if ((index_value<=N)&&(index_value>=1))
	{
		index_pointer=address+index_value-1;
		index_pointer2=address2+index_value-1;
		index=index_value;
		x=*index_pointer;
	}
}

template <class Type>
void		SpecialPoints<Type>::move_points(unsigned long	i)
{
	index=index+i;
	if (index<=N)
	{
		index_pointer+=i;
		index_pointer2+=i;
		x=*index_pointer;
	}
	else
		index-=i;
}


template <class Type>
void		SpecialPoints<Type>::quicksort(void)
{
	;
}


template <class Type>
BOOLEAN		SpecialPoints<Type>::put_point(Type value)
{
	Type	*pointer;
	signed char	*pointer2;
	if (used<N)
	{
		pointer=address+used;
		used++;
		*pointer=value;
		pointer2=address2+used;
		*pointer2=1;
		return(TRUE);
	}
	else{ /*extend the size of memory*/
		if (!change_size(ceil(N*1.5)))
			return(FALSE);
		pointer=address+used;
		used++;
		*pointer=value;
		pointer2=address2+used;
		*pointer2=1;
		return(TRUE);
	}
}

template <class Type>
void		SpecialPoints<Type>::print_points(void)
{
	unsigned long		i;
	Type	*pointer;
	signed char	*pointer2;
	
	pointer=address;
	pointer2=address2;
	cout << "Printing Points:\n" << "N="<<N<<"\nused="<<used;
	cout<< "\n   x   \n";
	for (i=1;i<=used;i++)
	{
		cout << *(pointer++) << "  << *(pointer2++) "<<"  \n" ;
	}
}

template <class Type>
void		SpecialPoints<Type>::set_point(Type value)
{
	if (*index_pointer2>=0){
		if (value<0)
			value=0;
		else if (value>255)
			value=255;

		*index_pointer+=value;
		*index_pointer2+=1;
	}
}

template <class Type>
void		SpecialPoints<Type>::special_set_point(Type value)
{
	*index_pointer=value;
	*index_pointer2=-1;
}

template <class Type>
void		SpecialPoints<Type>::increase_point(Type value)
{
	*index_pointer+=value;
	*index_pointer+=1;
}


template <class Type>
void		SpecialPoints<Type>::fill_with_zeros(void)//sets all points to (0,0)
{
	Type	*pointer;
	signed char	*pointer2;
	unsigned long		i;
	
	used=N;
	pointer=address;
	pointer2=address2;
	for (i=1;i<=N;i++)
	{
		*(pointer++)=0;
		*(pointer2++)=0;
	}
	x=0;
}

template <class Type>
void		SpecialPoints<Type>::clear_points(void)//sets all points to (0,0)
{
	Type	*pointer;
	signed char	*pointer2;
	unsigned long		i;
	
	pointer=address;
	pointer2=address2;
	for (i=1;i<=used;i++)
	{
		*(pointer++)=0;
		*(pointer2++)=0;
	}
	used=0;
	x=0;
}


template <class Type>
BOOLEAN		SpecialPoints<Type>::change_size(unsigned long	N1)
{
	long		response,i;
	Type		*address1_2,*first;
	void		*temp_address;
	signed char		*address2_2,*first2;
	void		*temp_address2;		

	/*write all points to disk.*/
	address1_2=(Type *)mymalloc(N1*sizeof(Type));
	temp_address=address;
	first=address1_2;
	address2_2=(signed char *)mymalloc(N1*sizeof(signed char));
	temp_address2=address2;
	first2=address2_2;
	for (i=1;i<=N;i++){
		*(address1_2++)=*(address++);
		*(address2_2++)=*(address2++);}
	used=N;
	N=N1;
	myfree(&temp_address,N);
	myfree(&temp_address2,N);
	address=first;
	address2=first2;
	return(TRUE);
}

template <class Type>
BOOLEAN		SpecialPoints<Type>::write_to_file(FILE*	stream)
{
	if (fwrite(address,sizeof(Type),used,stream)==used)
		return TRUE;
	else 
		return FALSE;
}


template <class Type>
BOOLEAN		SpecialPoints<Type>::write_to_textfile(FILE*	stream)
{
	unsigned long		i;
	
	for (i=0;i<used;i++){
		fprintf(stream,"%d point : %d\n",i,point_value(i));
	}
	return TRUE;
}


template <class Type>
void	SpecialPoints<Type>::normalise()
{
	Type	*pointer;
	signed char	*pointer2;
	long	i;

	pointer=address;
	pointer2=address2;
	for (i=1;i<=used;i++){
		if (*pointer2>1){
			*pointer=*pointer/(*pointer2);
			*pointer2=1;}
		pointer++;
		pointer2++;
	}
}

//*************************************************************
//Functions of Points2D class
template <class Type>
Points2D<Type>::Points2D(unsigned long number_of_points)
{
	N=number_of_points;
	used=0;
	index=0;
	x=0;
	y=0;
	address=(Type *)mymalloc(N*2*sizeof(Type));
	if (gerror.error_occured())
		return;
	index_pointer=address;
	#ifdef __DEBUG__
		cout << "Points2D allocated" << "\n" ;
	#endif
}



template <class Type>
BOOLEAN		Points2D<Type>::write_to_textfile(FILE*	stream)
{
	unsigned long		i;
	
	for (i=1;i<=used;i++){
		fprintf(stream,"%d point : %f,\t%f\n",i,pointx_value(i),pointy_value(i));
	}
	return TRUE;
}

template <class Type>
Points2D<Type>::Points2D(void )
{
	N=0;
	used=0;
	index=0;
	x=0;
	y=0;
	address=NULL;
	index_pointer=address;
	#ifdef __DEBUG__
		cout << "Points2D allocated" << "\n" ;
	#endif
}

template <class Type>
Points2D<Type>::~Points2D()
{
	void*	temp;

	if (this!=NULL)
	{
		temp=address;
		if (address!=NULL)
			myfree(&temp,N*sizeof(Type));
		#ifdef __DEBUG__
			cout << "Points2D deallocated" << "\n" ;
		#endif
	}
}

template <class Type>
Type	*Points2D<Type>::return_address()
{
	return(address);
}

template <class Type>
Type	*Points2D<Type>::return_index_pointer()
{
	return(index_pointer);
}

template <class Type>
void		Points2D<Type>::goto_next_point(void)
{
	Type	*y_p;
	if (index<N)
	{
		index_pointer++;
		index_pointer++;
		index++;
		x=*index_pointer;
		y_p=index_pointer+1;
		y=*y_p;
	}
}

template <class Type>
void		Points2D<Type>::goto_first_point(void)
{
	Type	*y_p;
	if (N!=0)
	{
		index=1;
		index_pointer=address;
		x=*index_pointer;
		y_p=index_pointer+1;
		y=*y_p;
	}
}

template <class Type>
void		Points2D<Type>::goto_index(unsigned long	index_value)
{
	if ((index_value<=N)&&(index_value>=1))
	{
		index_pointer=address+(index_value-1)*2;
		index=index_value;
		x=*(index_pointer++);
		y=*(index_pointer--);
	}
}

template <class Type>
void		Points2D<Type>::move_i_points(unsigned long	i)
{
	index=index+i;
	if (index<=N)
	{
		index_pointer+=2*i;
		x=*index_pointer;
		y=*(index_pointer+1);
	}
	else
		index-=i;
}

template <class Type>
void		Points2D<Type>::set_used(unsigned long used_value)
{
	if (used_value>N)
		used=N;
	else
		used=used_value;
}

template <class Type>
void		Points2D<Type>::set_N(unsigned long N_value)
{
	N=N_value;
}

template <class Type>
unsigned long	Points2D<Type>::index_value(void)
{
	return(index);
}

template <class Type>
Type	Points2D<Type>::pointx_value(void)
{
	return(x);
}

template <class Type>
Type	Points2D<Type>::pointy_value(void)
{
	return(y);
}


template <class Type>
Type	Points2D<Type>::pointx_value(uint4	i)
{
	Type	val;
	
	val=*(address+(i-1)*2);
	return(val);
}

template <class Type>
Type	Points2D<Type>::pointy_value(uint4	i)
{
	Type	val;
	
	val=*(address+(i-1)*2+1);
	return(val);
}


template <class Type>
void		Points2D<Type>::setx_value(Type	xvalue)
{
	if (index>used)
		used=index;
	x=xvalue;
	*index_pointer=x;
}

template <class Type>
void		Points2D<Type>::sety_value(Type	yvalue)
{
	if (index>used)
		used=index;
	y=yvalue;
	*(index_pointer+1)=y;
}

template <class Type>
unsigned long		Points2D<Type>::findx_value_index(Type x_value)
{
	int		up,down,middle;
	char		not_found;
	float	*pointer,*up_pointer,*down_pointer;
	
	up=1;
	down=used;
	up_pointer=address+2*(up-1);
	down_pointer=address+2*(down-1);
	not_found=1;
	if (*up_pointer==x_value)
		return(up);
	else if (*down_pointer==x_value)
		return(down);
	
	while ((down-up!=1)&&(not_found))
	{
		middle=(up+down)/2;
		pointer=address+2*(middle-1);
		if (*pointer==x_value)
		{
			not_found=0;//false
			return(middle);
		}
		else if (*pointer>x_value)
		{
			down=middle;
			pointer=down_pointer;
		}
		else
		{
			up=middle;
			pointer=up_pointer;
		}
	}
	if (*up_pointer==x_value)
		return(up);
	else if (*down_pointer==x_value)
		return(down);
	else return(0);
}

template <class Type>
void		Points2D<Type>::quicksort(void)
{
	;
}

template <class Type>
unsigned long		Points2D<Type>::how_many_points(void)
{
	return(used);
}

template <class Type>
unsigned long		Points2D<Type>::total_points(void)
{
	return(N);
}

template <class Type>
int		Points2D<Type>::put_point(Type xvalue,Type yvalue)
{
	Type	*pointer;
	if (used<N)
	{
		pointer=address+2*used;
		used++;
		*pointer=xvalue;
		*(pointer+1)=yvalue;
		return(0);
	}
	else
		return(1);
}

template <class Type>
void		Points2D<Type>::print_points(void)
{
	unsigned long	i;
	Type	*pointer;	
	
	pointer=address;
	cout << "Printing Points:\n" << "N="<<N<<"\nused="<<used;
	cout<< "\n   x          y     \n";
	for (i=1;i<=used;i++)
	{
		//cout << *(pointer++) << "  " << *(pointer++) <<"\n" ;
		cout << *(pointer++) << "  " ;
		//pointer++;
		cout << *(pointer++) << "  \n" ;
	}
}

template <class Type>
void		Points2D<Type>::set_point(unsigned long index_value,Type xvalue,Type yvalue)
{
	Type	*pointer;	
	
	if (index_value<=N)
	{
		pointer=address+(index_value-1)*2;
		*(pointer++)=xvalue;
		*pointer=yvalue;
		if (index_value>used)
			used=index_value;
	}
}

template <class Type>
void		Points2D<Type>::set_point2(Type xvalue1,Type xvalue,Type yvalue)
{
	Type	*pointer;	
	unsigned long		i=1;
	
	pointer=address;
	while ((*pointer!=xvalue1)&&(i<=used))
	{
		pointer++;
		pointer++;
		i++;
	}
	if (i>used)
	{
		*(pointer++)=xvalue;
		*pointer=yvalue;
	}
}

template <class Type>
void		Points2D<Type>::clear_points(void)//sets all points to (0,0)
{
	Type	*pointer;
	unsigned long		i;
	
	pointer=address;
	for (i=1;i<=used;i++)
	{
		*(pointer++)=0;
		*(pointer++)=0;
	}
	used=0;
	x=0;
	y=0;
}

template <class Type>
void		Points2D<Type>::change_size(unsigned long	N1)
{
	;
}

template <class Type>
double		Points2D<Type>::square_ysum(void)
{
	Type	*pointer;
	unsigned long	i;
	float	sum=0;
	
	pointer=address;
	for (i=1;i<=N;i++)
	{
		pointer++;
		sum+=sqr(*pointer);
		pointer++;
	}
	return(sum);
}

template <class Type>
double		Points2D<Type>::ysum(void)
{
	Type	*pointer;
	unsigned long	i;
	float	sum=0;
	
	pointer=address;
	for (i=1;i<=N;i++)
	{
		pointer++;
		sum+=(pointer);
		pointer++;
	}
	return(sum);
}

//*************************************************************
//Functions of Points3D class
template <class Type>
Points3D<Type>::Points3D(unsigned long number_of_points)
{
	N=number_of_points;
	used=0;
	index=0;
	x=0;
	y=0;
	z=0;
	address=(Type *)mymalloc(N*3*sizeof(Type));
	if (gerror.error_occured())
		return;
	index_pointer=address;
	#ifdef __DEBUG__
		cout << "Points3D allocated" << "\n" ;
	#endif
}

template <class Type>
Points3D<Type>::Points3D(void )
{
	N=0;
	used=0;
	index=0;
	x=0;
	y=0;
	z=0;
	address=NULL;
	index_pointer=address;
	#ifdef __DEBUG__
		cout << "Points3D allocated" << "\n" ;
	#endif
}

template <class Type>
Points3D<Type>::~Points3D()
{
	if (this!=NULL)
	{
		myfree((void**)&address,3*N*sizeof(Type));
		#ifdef __DEBUG__
			cout << "Points3D deallocated" << "\n" ;
		#endif
	}
}

template <class Type>
Type	*Points3D<Type>::return_address()
{
	return(address);
}

template <class Type>
Type	*Points3D<Type>::return_index_pointer()
{
	return(index_pointer);
}

template <class Type>
void		Points3D<Type>::goto_next_point(void)
{
	Type	*y_p;
	Type	*z_p;
	if (index<N)
	{
		index_pointer++;
		index_pointer++;
		index_pointer++;
		index++;
		x=*index_pointer;
		y_p=index_pointer+1;
		y=*y_p;
		z_p=index_pointer+2;
		z=*z_p;
	}
}

template <class Type>
void		Points3D<Type>::goto_first_point(void)
{
	Type	*y_p;
	Type	*z_p;
	if (N!=0)
	{
		index=1;
		index_pointer=address;
		x=*index_pointer;
		y_p=index_pointer+1;
		y=*y_p;
		z_p=index_pointer+2;
		z=*z_p;
	}
}

template <class Type>
void		Points3D<Type>::goto_index(unsigned long	index_value)
{
	if ((index_value<=N)&&(index_value>=1))
	{
		index_pointer=address+(index_value-1)*3;
		index=index_value;
		x=*(index_pointer);
		y=*(index_pointer+1);
		z=*(index_pointer+2);
	}
}

template <class Type>
void		Points3D<Type>::move_i_points(unsigned long	i)
{
	index=index+i;
	if (index<=N)
	{
		index_pointer+=3*i;
		x=*index_pointer;
		y=*(index_pointer+1);
		z=*(index_pointer+2);
	}
	else
		index-=i;
}

template <class Type>
void		Points3D<Type>::set_used(unsigned long used_value)
{
	if (used_value>N)
		used=N;
	else
		used=used_value;
}

template <class Type>
void		Points3D<Type>::set_N(unsigned long N_value)
{
	N=N_value;
}

template <class Type>
unsigned long	Points3D<Type>::index_value(void)
{
	return(index);
}

template <class Type>
Type	Points3D<Type>::pointx_value(void)
{
	return(x);
}

template <class Type>
Type	Points3D<Type>::pointy_value(void)
{
	return(y);
}

template <class Type>
Type	Points3D<Type>::pointz_value(void)
{
	return(z);
}


template <class Type>
Type	Points3D<Type>::pointx_value(int	i)
{
	Type	val;
	
	val=*(address+(i-1)*3);
	return(val);
}

template <class Type>
Type	Points3D<Type>::pointy_value(int	i)
{
	Type	val;
	
	val=*(address+(i-1)*3+1);
	return(val);
}

template <class Type>
Type	Points3D<Type>::pointz_value(int	i)
{
	Type	val;

	val=*(address+(i-1)*3+2);
	return(val);
}

template <class Type>
void		Points3D<Type>::setx_value(Type	xvalue)
{
	if (index>used)
		used=index;
	x=xvalue;
	*index_pointer=x;
}

template <class Type>
void		Points3D<Type>::sety_value(Type	yvalue)
{
	if (index>used)
		used=index;
	y=yvalue;
	*(index_pointer+1)=y;
}

template <class Type>
void		Points3D<Type>::setz_value(Type	zvalue)
{
	if (index>used)
		used=index;
	z=zvalue;
	*(index_pointer+2)=z;
}


template <class Type>
unsigned long		Points3D<Type>::findxy_value_index(Type x_value,Type y_value)
{
	int		i=1;
	char		not_found;
	float	*pointer;
	
	goto_first_point();
	while (i<N)
	{
		if (x==x_value)
			if (y==y_value)
				return(i);
		goto_next_point();
	}		
}

template <class Type>
void		Points3D<Type>::quicksort(void)
{
	;
}

template <class Type>
unsigned long		Points3D<Type>::how_many_points(void)
{
	return(used);
}

template <class Type>
unsigned long		Points3D<Type>::total_points(void)
{
	return(N);
}

template <class Type>
int		Points3D<Type>::put_point(Type xvalue,Type yvalue,Type zvalue)
{
	Type	*pointer;
	if (used<N)
	{
		pointer=address+3*used;
		used++;
		*pointer=xvalue;
		*(pointer+1)=yvalue;
		*(pointer+2)=zvalue;
		return(0);
	}
	else
		return(1);
}

template <class Type>
void		Points3D<Type>::print_points(void)
{
	unsigned long	i;
	Type	*pointer;	
	
	pointer=address;
	cout << "Printing Points:\n" << "N="<<N<<"\nused="<<used;
	cout<< "\n   x          y          z     \n";
	for (i=1;i<=used;i++)
	{
		cout << *(pointer++) << "  " ;
		cout << *(pointer++) << "  " ;
		cout << *(pointer++) << "  \n" ;
	}
}

template <class Type>
void		Points3D<Type>::set_point(unsigned long index_value,Type xvalue,Type yvalue,Type zvalue)
{
	Type	*pointer;	
	
	if (index_value<=N)
	{
		pointer=address+(index_value-1)*3;
		*(pointer++)=xvalue;
		*(pointer++)=yvalue;
		*pointer=zvalue;
		if (index_value>used)
			used=index_value;
	}
}


template <class Type>
void		Points3D<Type>::clear_points(void)//sets all points to (0,0)
{
	Type	*pointer;
	unsigned long		i;
	
	pointer=address;
	for (i=1;i<=used;i++)
	{
		*(pointer++)=0;
		*(pointer++)=0;
		*(pointer++)=0;
	}
	used=0;
	x=0;
	y=0;
	z=0;
}

template <class Type>
void		Points3D<Type>::change_size(unsigned long	N1)
{
	;
}

template <class Type>
double		Points3D<Type>::sumz2(void)
{
	Type	*pointer;
	unsigned long	i;
	float	sum=0;
	
	pointer=address+2;
	for (i=1;i<=used;i++)
	{
		sum+=sqr(*pointer);
		pointer+=3;
	}
	return(sum);
}

template <class Type>
double		Points3D<Type>::sumz(void)
{
	Type	*pointer;
	unsigned long	i;
	float	sum=0;
	
	pointer=address+2;
	for (i=1;i<=used;i++)
	{
		sum+=(*pointer);
		pointer+=3;
	}
	return(sum);
}

template <class Type>
double		Points3D<Type>::meanz(void)
{
	Type	*pointer;
	unsigned long	i;
	double	sum=0;
	
	pointer=address+2;
	for (i=1;i<=used;i++)
	{
		sum+=(*pointer);
		pointer+=3;
	}
	return(sum/used);
}

template <class Type>
double		Points3D<Type>::sumx(void)
{
	Type	*pointer;
	unsigned long	i;
	float	sum=0;
	
	pointer=address;
	for (i=1;i<=used;i++)
	{
		sum+=(*pointer);
		pointer+=3;
	}
	return(sum);
}

template <class Type>
double		Points3D<Type>::sumx2(void)
{
	Type	*pointer;
	unsigned long	i;
	float	sum=0;
	
	pointer=address;
	for (i=1;i<=used;i++)
	{
		sum+=sqr(*pointer);
		pointer+=3;
	}
	return(sum);
}


template <class Type>
double		Points3D<Type>::sumy(void)
{
	Type	*pointer;
	unsigned long	i;
	float	sum=0;
	
	pointer=address+1;
	for (i=1;i<=used;i++)
	{
		sum+=(*pointer);
		pointer+=3;
	}
	return(sum);
}

template <class Type>
double		Points3D<Type>::sumy2(void)
{
	Type	*pointer;
	unsigned long	i;
	float	sum=0;
	
	pointer=address+1;
	for (i=1;i<=used;i++)
	{
		sum+=sqr(*pointer);
		pointer+=3;
	}
	return(sum);
}


template <class Type>
double		Points3D<Type>::sumxy(void)
{
	Type	*pointer;
	unsigned long	i;
	float	sum=0;
	
	pointer=address;
	for (i=1;i<=used;i++)
	{
		sum+=(*pointer)*(*(pointer+1));
		pointer+=3;
	}
	return(sum);
}



/************************************************************
It takes some points (stored inside Points3D) and finds the sum of 
squares distances from the line ax+by+c=0.
*************************************************************/
template <class Type>
uint4	Points3D<Type>::mean_square_distances_from_line(float a, float b, float c)
{
	uint4	D=0;
	uint2	i;
	Type	*pointer=address;

	for(i=1;i<=used;i++){
		D+=*(pointer++)*a+*(pointer++)*b+c;
		pointer++;
	}
	return D;
}


/*******************************************************/
/*
It takes some points (stored inside Points3D) and finds the least squares line
(i.e. the line that passes as closer as possible from the points according to
the least squares method.) It stores the parameters inside a and c. The line
is ax+y+c=0.
*/
template <class Type>
void	Points3D<Type>::find_param_LSM(float &a, float &b, float &c)
{
	int4	Sx=this->sumx();
	int4	Sx2=this->sumx2();
	int4	Sy=this->sumy();
	int4	Sy2=this->sumy2();
	int4	Sxy=this->sumxy();
	int		n=this->how_many_points();
	float	a1,b1,c1,a2,b2,c2,D1,D2;

	float	T=n*Sx2-Sx*Sx;
	if (T==0){
		a=0;
		b=1;
		c=-sqrt(Sx2/n);
	}
	else{
		//Variance of X
		float	V=Sx2/n-sqr(Sx/n);
		if (V<12){ //Variance low
			a1=1;
			b1=0;
			c1=-sqrt(Sx2/n);
			D1=mean_square_distances_from_line(a1,b1,c1);
			a2=-(n*Sxy-Sx*Sy)/(T);
			c2=-Sy/n-a2*Sx/n;
			b2=1;
			D2=mean_square_distances_from_line(a2,b2,c2);
			if (D1<D2){
				a=a1;
				b=b1;
				c=c1;
			}
			else{
				a=a2;
				b=b2;
				c=c2;
			}
		}
		else{
			a=-(n*Sxy-Sx*Sy)/(T);
			c=-Sy/n-a*Sx/n;
			b=1;
		}
	}
}



/*******************************************************/
/*
It takes some points (stored inside Points3D) and finds the least squares line
(i.e. the line that passes as closer as possible from the points according to
the least squares method.) The parameter a, which defines the direction
of the line is predefined. It stores the other parameter inside c. The line
is ax+y+c=0.
*/
template <class Type>
void	Points3D<Type>::find_param_LSM2(float a, float b, float &c)
{
	int4	Sx=this->sumx();
	int4	Sy=this->sumy();
	int		n=this->how_many_points();
	if (b==0){
		int4	Sx2=this->sumx2();
		c=-sqrt(Sx2/n);
	}
	else
		c=-(float)Sy/n-a*(float)Sx/n;
}
/*******************************************************/
template <class Type>
void	Points3D<Type>::swap(Type *pointer1, Type *pointer2)
{
	Type temp,*p1,*p2;
	p1=pointer1;
	p2=pointer2;
	unsigned int	i;

	for (i=1;i<=3;i++){
		temp=*p1;
		*p1=*p2;
		*p2=temp;
		p1++;
		p2++;
	}
}

template <class Type>
void	Points3D<Type>::swap(unsigned long	i1, unsigned long	i2)
{
	Type temp,*p1,*p2;
	p1=address+(i1-1)*3;
	p2=address+(i2-1)*3;
	
	swap(p1,p2);

}
/*******************************************************/
/*
It takes some points (stored inside Points3D) and finds the least squares line
(i.e. the line that passes as closer as possible from the points according to
the least squares method.) Then it removes the most far away from the line point.
It repeats the previous steps, until there is no point with distance from
the line greater than e.
*/
template <class Type>
void	Points3D<Type>::remove_far_away_from_LSML_points(float	e)
{
	bool	flag=0;
	float	a,b,c;
	float	*D,*dist,*d1,*d2,temp_f;
	unsigned long	i,j;

	while ((flag==0)&&(used>2)){
		//find line!
		find_param_LSM(a,b,c);
    
		//calculate the distance of each point from the line.
		//store them inside D.
		D=(float *)mymalloc(used*sizeof(float));
		dist=D;
		for (j=1;j<=used;j++){
			*(dist++)=fabs(a*pointx_value(j)+b*pointy_value(j)+c)/sqrt(sqr(a)+sqr(b));
		}
		//bubblesort. We sort D, without losing the correspondencies with this.
		for (i=2;i<=used;i++){
			d1=D+used-1;
			for (j=used;j>=i;j--){
				d2=d1-1;
				if (*d1<*d2){
					//swap the distances j and j-1.
                    temp_f=*d1;
                    *d1=*d2;
                    *d2=temp_f;
					//swap point j and j-1
					swap(j,j-1);
                }
				d1--;
            }
        }
		
		//check the last distance to see if it is greater than e.
		dist=D+used-1;
		if (*dist>e){
			myfree((void**)&D,used*sizeof(float));
			used=used-1;
		}
		else{
			myfree((void**)&D,used*sizeof(float));
			flag=1;
		}
	}
}



/*******************************************************/
/*
It takes some points (stored inside Points3D) and finds the least squares line
(i.e. the line that passes as closer as possible from the points according to
the least squares method.) Then it removes the most far away from the line point.
It repeats the previous steps, until there is no point with distance from
the line greater than e. All lines have predefined a.
*/
template <class Type>
void	Points3D<Type>::remove_far_away_from_LSML_points2(float	e,float a,float b)
{
	bool	flag=0;
	float	c;
	float	*D,*dist,*d1,*d2,temp_f;
	unsigned long	i,j;

	while ((flag==0)&&(used>2)){
		//find line!
		find_param_LSM2(a,c,b);
    
		//calculate the distance of each point from the line.
		//store them inside D.
		D=(float *)mymalloc(used*sizeof(float));
		dist=D;
		for (j=1;j<=used;j++){
			*(dist++)=fabs(a*pointx_value(j)+b*pointy_value(j)+c)/sqrt(sqr(a)+sqr(b));
		}
		//bubblesort. We sort D, without losing the correspondencies with this.
		for (i=2;i<=used;i++){
			d1=D+used-1;
			for (j=used;j>=i;j--){
				d2=d1-1;
				if (*d1<*d2){
					//swap the distances j and j-1.
                    temp_f=*d1;
                    *d1=*d2;
                    *d2=temp_f;
					//swap point j and j-1
					swap(j,j-1);
                }
				d1--;
            }
        }
		
		//check the last distance to see if it is greater than e.
		dist=D+used-1;
		if (*dist>e){
			myfree((void**)&D,used*sizeof(float));
			used=used-1;
		}
		else{
			myfree((void**)&D,used*sizeof(float));
			flag=1;
		}
	}
}

#endif
