
 
//#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <winsock2.h> 
#include "mem.h"
#include "mypoints.h"
#include <time.h>
#include <string.h>
#include <iostream.h>
#include "IFS_map.h"
#include "prngs.h"
#include <time.h>
#include <math.h>



extern "C" typedef long * verylong;
extern "C" void zadd(verylong a, verylong b, verylong *c);
extern "C" void zmul(verylong a, verylong b, verylong *c);
extern "C" void zmod(verylong a, verylong b, verylong *r);
extern "C" void zone(verylong *a);
extern "C" void zuintoz(unsigned long d, verylong *a);
extern "C" void zsadd(verylong a, long d, verylong *b);
extern "C" void zexp(verylong a, verylong e, verylong *b);
extern "C" void zsub(verylong a, verylong b, verylong *c);
extern "C" void zfree(verylong *x);
extern "C" unsigned long ztouint(verylong a);
extern "C" void zwriteln(verylong a);
extern "C" void zcopy(verylong a, verylong *b);

//#include "QHEAD.H"
//#include "QFLOAT.H"

#define	STEPS 10
#define EXTRA_ATTRACTORS	0
#define MAX_POINTS	25000000			//attractors of value
#define MAX_POINTS2	13000000		//attractors of indeces must be much bigger than
									//the attractors of value max points.
#define MAX_POINTS3	10000000
#define MAX_CODES 251
#define MAX_RAND_NUMBERS	3000000
#define POINTS_BUFFER	10000000








//This code impements the Recycled Modulus Deterministic Algorithm for FIF
//for constructing Pseudo random numbers.

//codes: a buffer (N bytes) consisting of the numbers of the seed.
//N: the number of numbers of the seed. (<MAX_CODES)
//points: the number of random numbers that the user wants to create
//bit_stream: a FILE. The function writes in that file
//the bits (as text characters) of the random numbers.
//the respective code (at the end) is not enabled.
//If one wants to test the random numbers with the NIST test program
//must enable this code.
//byte_stream: a FILE. The function writes in that file the 
//random numbers (as bytess). The file may be used 
//with the ENT or the Diehard test. 
void SIMPLE_NON_CONV_MANY_IFS_PRNG_BIT_GEN(
					uint4	*codes, 
					uint2	N, 
					uint4	points,
					FILE	*bit_stream,
					FILE	*byte_stream)
{
	uint4	i,j,k; 
	uint4	S=0,pos,apos,pos3;
	double	S1;
	uint4	N1;
	double	x[MAX_CODES],y[MAX_CODES],a[MAX_CODES],e[MAX_CODES],
				s[MAX_CODES],c[MAX_CODES],f[MAX_CODES],P,temp_double;
	for (i=1;i<=N;i++)
		S+=codes[i];
	codes[0]=codes[N];
	
	BYTE	byte;
	double	Ncodes[MAX_CODES],Ncodes2[MAX_CODES];
	uint4	index;
	double	y1,y2,psi,ni,mi_i,si,line_psi;
	uint4	x1,x2,start,xi,ip_pos,cf_pos,bits;
	uint4	codes2[MAX_CODES];
	uint4	codes3[MAX_CODES];
	Points<double>	*mapped_attractor;
	Points<double>	*indeces_attractor;
	Points<double>	*temp_attractor;
	FILE	*debug_file;
	uint1	attractor_value,temp_uint1;
	double	temp,temp2,MO; 
	double	temp_x;

	pos=0;//position index of the original stream.
	ip_pos=0;
	cf_pos=0;
	uint1	total_steps=6;//an arbitrary value. See the paper for details
 
	//the random points produced by each IFS.
	uint4   AN2=round(pow(N-1.0,total_steps)+1.0); 
	uint2	M=5;
	uint2	M2=5;
	uint2	attractors=0;
	uint4	total_points=points-points%AN2;//the total points that the program will produce
	BYTE*	attractor;
	uint4	thesis=0;
	double		temp_mod=0;
	temp_mod=pow(2,40);
	//for the initial contraction factors
	for (i=1;i<=N;i++)
		codes3[i]=codes[i];
	//for the initial set
	for (i=1;i<=N;i++)
		codes2[i]=codes[i];
	do{//In each iteration we produce random numbers using a different IFS
		attractor=(BYTE*)malloc(AN2);
		for(i=0;i<AN2;i++){
			attractor[i]=0;//the attractor of the IFS
		} 
		for (k=1;k<=8;k++){//8 times
			mult2(codes,M,Ncodes,N,k);//for the mappings
			mult2(codes2,M2,Ncodes2,N,k);//for the initial set
			S=0; 
			for (i=1;i<=N;i++)
				S+=2*codes[i];
			//The N interpolation points are
			//x=0, S, 2S, 3S, ... , (N-1)S
			//y=Ncodes[1], Ncodes[2], Ncodes[N]
			//the are contained inside indeces_attractor (initial set)
			indeces_attractor=new Points<double>(N);
			indeces_attractor->set_used(N);
			x[0]=0;
			for (j=1;j<=N;j++){
				indeces_attractor->goto_index(j);
				y[j-1]=Ncodes[j];
				indeces_attractor->set_point(Ncodes2[j]);
				x[j]=x[j-1]+S;
			}
			//then define the mappings (N-1) of the corresponding IFS
			for (i=1;i<=N-1;i++){
				a[i]=(x[i]-x[i-1])/(x[N-1]-x[0]);
				e[i]=(x[N-1]*x[i-1]-x[0]*x[i])/(x[N-1]-x[0]);
				//set a random s[i] in (-1,1) 0,1/256,2/256,...255/256
				if (codes3[i]%2==0){
					s[i]=(double)round((float)(codes2[i]/4)+5);
				}
				else{
					s[i]=-(double)round((float)(codes2[i]/4)+5);
				}
				c[i]=(y[i]-y[i-1])/(x[N-1]-x[0])-s[i]*(y[N-1]-y[0])/(x[N-1]-x[0]);
				f[i]=(x[N-1]*y[i-1]-x[0]*y[i])/(x[N-1]-x[0])-s[i]*(x[N-1]*y[0]-x[0]*y[N-1])/(x[N-1]-x[0]);
			} 
			//start mapping points through the IFS
			for (i=1;i<total_steps;i++){ 
				mapped_attractor=IFSR2_simple_map_points2D(indeces_attractor,a,e,s,c,f,N-1,S*(N-1));
				
				for (j=1;j<=mapped_attractor->total_points();j++){
					mapped_attractor->goto_index(j);
					temp_double=myfmod(mapped_attractor->point_value(),temp_mod);
					mapped_attractor->set_point(temp_double);
				}
				
				delete indeces_attractor;
				indeces_attractor=mapped_attractor;
			}
			//after the construction of the attractor 
			//we implement a XOR with the other 7 operators.
			//the outcome is written in the buffer attractor
			AN2=indeces_attractor->how_many_points();
			pos=0;
			bits=0;
			while (pos<AN2){
				temp=floor(indeces_attractor->point_value(pos+1));
				temp_uint1=round(fmod(temp,256));
				attractor[pos]^=temp_uint1;
				pos++;
			}
			delete indeces_attractor;
		}
		//from the attractor just constructed (after the XOR) 
		//we extract some points to form the next IFS
		pos3=thesis;
		S1=0;
		N1=AN2/(2*N);
		for (i=1;i<=N;i++)
		{
			S1=attractor[/*pos3*/+(i-1)*N1+N1/2];
			codes2[i]=round(fmod(S1,256));

			i++;
			S1=attractor[/*pos3*/+(i-1)*N1+N1/2];
			codes3[i]=round(fmod(S1,256));
		}

		//write bytes to file	
		write_uint1_buffer_to_file(attractor,AN2,byte_stream);
		//for NIST testing you must enable the following code
		//write bits to a file as chars
		/*BYTE	bit;
		BYTE*	bits=(BYTE*)malloc(AN2*8);
		k=0;
		for (i=0;i<AN2;i++){
			byte=attractor[i];
			for (j=0;j<8;j++){
				bit=byte%2;
				byte=byte/2;
				bits[k+7-j]=bit+48;
			}
			k=k+8;
		}
		write_uint1_buffer_to_file(bits,AN2*8,bit_stream);
		free(bits);*/
		attractors++;
		thesis+=AN2;
		free(attractor); 
		printf("BYTES:\t%ld\n",thesis);
	}while (thesis+AN2<=total_points);//stop if you create enough points.
}







//This code impements the Recycled Modulus Deterministic Algorithm for HVFIF
//for constructing Pseudo random numbers.

//codes: a buffer (N bytes) consisting of the numbers of the seed.
//N: the number of numbers of the seed. (<MAX_CODES)
//points: the number of random numbers that the user wants to create
//bit_stream: a FILE. The function writes in that file
//the bits (as text characters) of the random numbers.
//the respective code (at the end) is not enabled.
//If one wants to test the random numbers with the NIST test program
//must enable this code.
//byte_stream: a FILE. The function writes in that file the 
//random numbers (as bytess). The file may be used 
//with the ENT or the Diehard test. 
void SIMPLE_NON_CONV_MANY_HVIFS_PRNG_BIT_GEN(uint4 *codes, uint2 N,
					uint4	points,
					FILE	*bit_stream,
					FILE	*byte_stream)
{
	uint4	i,j,k;
	uint4	S=0,pos,apos;
	double	x[MAX_CODES],y1[MAX_CODES],y2[MAX_CODES],a[MAX_CODES],e[MAX_CODES],
				s11[MAX_CODES],s12[MAX_CODES],s21[MAX_CODES],s22[MAX_CODES],
				b[MAX_CODES],c[MAX_CODES],d[MAX_CODES],f[MAX_CODES],P,temp_double;
	
	codes[0]=codes[N];
	
	BYTE	byte;
	double	Ncodes0[MAX_CODES],Ncodes1[MAX_CODES],S1,Ncodes2[MAX_CODES],Ncodes3[MAX_CODES];
	uint4	index;
	double	psi,ni,mi_i,si,line_psi;
	uint4	x1,x2,start,xi,ip_pos,cf_pos,pos3,N1;
	uint4	codes2[MAX_CODES],codes3[MAX_CODES],codes0[MAX_CODES],codes1[MAX_CODES],codes4[MAX_CODES];
	Points<double>	*mapped_attractor;
	Points<double>	*indeces_attractor;
	FILE	*debug_file;
	uint1	attractor_value;
	double	temp,MO;
	uint1	temp_uint1;

	pos=0;//position index of the original stream.
	ip_pos=0;
	cf_pos=0;
	uint1	total_steps=6;//an arbitrary value. See the paper for details
	uint4 AN2=round(pow(N-1.0,total_steps)+1.0);

	uint4	total_points=points-points%(2*AN2);
	
	uint2	M=5;
	uint2	M2=5;
	uint2	attractors=0;
	BYTE*	attractor;
	uint4	thesis=0;
	double		temp_mod=0;
	for (i=1;i<=M2;i++)
		temp_mod=temp_mod*256+256;

	//for the initial points
	for (i=1;i<=N;i++)
		codes0[i]=codes[i];
	for (i=1;i<=N;i++)
		codes1[i]=codes[N+i];
	//for the initial points
	for (i=1;i<=N;i++)
		codes3[i]=codes[i];
	for (i=1;i<=2*N;i++)
		codes4[i]=codes[N+i];
	//for the contraction factors
	for (i=1;i<=2*N;i++){
		codes2[i]=codes[i];
		codes2[2*N+i]=codes[i];
	}
	do{//In each iteration we produce random numbers using a different IFS
		attractor=(BYTE*)malloc(2*AN2);
		for(i=0;i<2*AN2;i++){
			attractor[i]=0;
		}
		for (k=1;k<=8;k++){
			mult2(codes0,M,Ncodes0,N,k);//for the mappings y1
			mult2(codes1,M,Ncodes1,N,k);//for the mappings y2
			mult2(codes3,M2,Ncodes2,N,k);//for the initial set
			mult2(codes4,M2,Ncodes3,N,k);//for the initial set
			
			for (i=1;i<=N;i++)
				S+=2*codes[i];
			
			//create the attractor of indeces!
			//The N interpolation points are
			//x=0, S, 2S, 3S, ... , (N-1)S
			//y=Ncodes[1], Ncodes[2], Ncodes[N]
			indeces_attractor=new Points<double>(2*N);
			indeces_attractor->set_used(2*N);
			x[0]=0;
			for (j=1;j<=N;j++){
				indeces_attractor->goto_index(2*j-1);
				y1[j-1]=Ncodes0[j];
				indeces_attractor->set_point(Ncodes2[j]);
				indeces_attractor->goto_index(2*j);
				y2[j-1]=Ncodes1[j];
				indeces_attractor->set_point(Ncodes3[j]);
				x[j]=x[j-1]+S;
			}
			//then define the mappings (N-1) of the corresponding IFS
			for (i=1;i<=N-1;i++){
				a[i]=(x[i]-x[i-1])/(x[N-1]-x[0]);
				b[i]=x[i-1]-a[i]*x[0];
				//set a random s[i] in (-1,1) 0,1/256,2/256,...255/256
				if (codes2[i]%2==0){
					s11[i]=round((double)codes2[i]/4+5);
				}
				else{
					s11[i]=-round((double)codes2[i]/4+5);
				}
				if (codes2[N+i]%2==0){
					s12[i]=round((double)codes2[N+i]/4+5);
				}
				else{
					s12[i]=-round((double)codes2[N+i]/4+5);
				}
				if (codes2[i]%2==0){
					s21[i]=round((double)codes2[i]/4+5);
				}
				else{
					s21[i]=-round((double)codes2[i]/4+5);
				}
				if (codes2[N+i]%2==0){
					s22[i]=round((double)codes2[N+i]/4+5);
				}
				else{
					s22[i]=-round((double)codes2[N+i]/4+5);
				}
				c[i]=(y1[i]-y1[i-1])/(x[N-1]-x[0])-s11[i]*(y1[N-1]-y1[0])/(x[N-1]-x[0])-s12[i]*(y2[N-1]-y2[0])/(x[N-1]-x[0]);
				e[i]=(y2[i]-y2[i-1])/(x[N-1]-x[0])-s11[i]*(y1[N-1]-y1[0])/(x[N-1]-x[0])-s12[i]*(y2[N-1]-y2[0])/(x[N-1]-x[0]);
				d[i]=y1[0]-c[i]*x[0]-s11[i]*y1[0]-s12[i]*y2[0];
				f[i]=y2[0]-e[i]*x[0]-s21[i]*y1[0]-s22[i]*y2[0];
			}
			//start mapping points through the IFS
			for (i=1;i<total_steps;i++){
				mapped_attractor=HVIFSR2_simple_map_points2D(indeces_attractor,a,c,e,s11,s12,s21,s22,b,d,f,N-1,S*(N-1));
				for (j=1;j<=mapped_attractor->total_points();j++){
					mapped_attractor->goto_index(j);
					temp_double=myfmod(mapped_attractor->point_value(),temp_mod);
					mapped_attractor->set_point(temp_double);
				}
				delete indeces_attractor;
				indeces_attractor=mapped_attractor;
			}
			
			//after the construction of the attractor 
			//we implement a XOR with the other 7 operators.
			//the outcome is written in the buffer attractor
			pos=0;
			while (pos<2*AN2){
				//attractor[thesis+pos]<<=1;
				temp=floor(indeces_attractor->point_value(pos+1));
				temp_uint1=fmod(fabs(temp),256);
				attractor[/*thesis+*/pos]^=temp_uint1;
				pos++;
			}
			delete indeces_attractor;
		}
		//from the attractor just constructed (after the XOR) 
		//we extract some points to form the next IFS
		pos3=thesis;
		S1=0;
		N1=2*AN2/(2*N);
		for (i=1;i<=2*N;i++)
		{
			S1=attractor[/*pos3+*/(i-1)*N1+N1/2];
			codes3[i]=(fmod(S1,256)+1);
		}
		N1=2*AN2/(4*N);
		for (i=1;i<=4*N;i++)
		{
			S1=attractor[/*pos3*/+(i-1)*N1+N1/2+1];
			codes2[i]=(fmod(S1,256)+1);
		} 
		
		//write bytes to file	
		write_uint1_buffer_to_file(attractor,2*AN2,byte_stream);
		//for NIST testing you must enable the following code
		//write bits to a file as chars
		/*BYTE	bit;
		BYTE*	bits=(BYTE*)malloc(2*AN2*8);
		k=0;
		for (i=0;i<2*AN2;i++){
			byte=attractor[i];
			for (j=0;j<8;j++){
				bit=byte%2;
				byte=byte/2;
				bits[k+7-j]=bit+48;
			}
			k=k+8;
		}
		write_uint1_buffer_to_file(bits,2*AN2*8,bit_stream);
		free(bits);*/
		free(attractor);
		attractors++;
		thesis+=2*AN2;
		printf("BYTES:\t%ld\n",thesis);
	}while (thesis+2*AN2<=total_points);
}















//This code impements the Modulus Deterministic Algorithm for FIF
//for constructing Pseudo random numbers.
//It stores the numbers produced in each iteration to files
//as described in the paper. Be carefull with the usage of the hard disk.
//Make sure there is enough space.

//codes: a buffer (N bytes) consisting of the numbers of the seed.
//N: the number of numbers of the seed. (<MAX_CODES)
//points: the number of random numbers that the user wants to create
//bit_stream: a FILE. The function writes in that file
//the bits (as text characters) of the random numbers.
//the respective code (at the end) is not enabled.
//If one wants to test the random numbers with the NIST test program
//must enable this code.
//byte_stream: a FILE. The function writes in that file the 
//random numbers (as bytess). The file may be used 
//with the ENT or the Diehard test. 

void	SIMPLE_NON_CONV_MANY_IFS_PRNG_BIT_GEN_USING_FILES(uint4 *codes, uint2 N,
					uint4	points,
					FILE	*bit_stream,
					FILE	*byte_stream)
{
	uint4	i,j,k; 
	uint4	S=0,pos,apos,pos3;
	double	S1;
	uint4	N1;
	double	x[MAX_CODES],y[MAX_CODES],a[MAX_CODES],e[MAX_CODES],
				s[MAX_CODES],c[MAX_CODES],f[MAX_CODES],P,temp_double;
	for (i=1;i<=N;i++)
		S+=codes[i];
	codes[0]=codes[N];
	
	BYTE	byte;
	double	Ncodes[MAX_CODES],Ncodes2[MAX_CODES];
	uint4	index;
	double	y1,y2,psi,ni,mi_i,si,line_psi;
	uint4	x1,x2,start,xi,ip_pos,cf_pos;
	uint4	codes2[MAX_CODES];
	uint4	codes3[MAX_CODES];
	Points<double>	*mapped_attractor;
	Points<double>	*indeces_attractor;
	Points<double>	*temp_attractor;
	FILE	*debug_file;
	uint1	attractor_value,temp_uint1;
	double	temp,temp2,MO; 
	double	temp_x;
	FILE	*read_file,*write_file,*attr_file;
	char	read_name[11],write_name[11],fread_name[11],fwrite_name[11],temp_name[11];
	__int64	filepos;
	uint1	int_temp;
	uint1	*buffer;
	double	*dbuffer;
	uint4	items_read;
	uint1	total_steps;

	//initialise files
	write_file=fopen("temp_1.bin","wb+");
	fclose(write_file);
	write_file=fopen("temp_2.bin","wb+");
	fclose(write_file);
	write_file=fopen("bytes.bin","wb+");
	fclose(write_file);
	write_file=fopen("final1.bin","wb+");
	fclose(write_file);
	write_file=fopen("final2.bin","wb+");
	fclose(write_file);

	pos=0;//position index of the original stream.
	ip_pos=0;
	cf_pos=0;
	total_steps=floor(log(points-1)/log(N-1));
	uint4 AN2=pow(N-1,total_steps)+1;
	


 
	AN2=round(pow(N-1.0,total_steps)+1.0);
	memcpy(fread_name,"bytes.bin",11);
	memcpy(fwrite_name,"final2.bin",11);

	//initialise the file with AN2 0's
	write_file=fopen(fread_name,"wb+");
	pos=0;
	while (pos+POINTS_BUFFER<AN2){
		buffer=(uint1*)malloc(sizeof(uint1)*POINTS_BUFFER);
		for(i=0;i<POINTS_BUFFER;i++)
			buffer[i]=0;
		fwrite(buffer,sizeof(uint1),POINTS_BUFFER,write_file);
		pos+=POINTS_BUFFER;
		free(buffer);
	}
	buffer=(uint1*)malloc(sizeof(uint1)*(AN2%POINTS_BUFFER));
	for(i=0;i<AN2%POINTS_BUFFER;i++)
		buffer[i]=0;
	fwrite(buffer,sizeof(uint1),AN2%POINTS_BUFFER,write_file);
	free(buffer);
	fclose(write_file);


	uint2	M=5;
	uint2	M2=5;
	uint4	thesis=0;
	double		temp_mod=0;
	for (i=1;i<=M2;i++)
		temp_mod=temp_mod*256+256;
	//for the initial contraction factors
	for (i=1;i<=N;i++)
		codes3[i]=codes[N+i];
	//for the initial set
	for (i=1;i<=N;i++)
		codes2[i]=codes[i];
		 
	for (k=1;k<=8;k++){
		mult2(codes,M,Ncodes,N,k);//for the mappings
		mult2(codes2,M2,Ncodes2,N,k);//for the initial set
		S=0;
		for (i=1;i<=N;i++)
			S+=codes[i];
		//create the attractor of indeces!
		//The N interpolation points are
		//x=0, S, 2S, 3S, ... , (N-1)S
		//y=Ncodes[1], Ncodes[2], Ncodes[N]
		dbuffer=(double*)malloc(sizeof(double)*N);
		x[0]=0;
		for (j=1;j<=N;j++){
			y[j-1]=Ncodes[j];
			dbuffer[j-1]=(Ncodes2[j]);
			x[j]=x[j-1]+S;
		}
		//then define the mappings (N-1)
		for (i=1;i<=N-1;i++){
			a[i]=(x[i]-x[i-1])/(x[N-1]-x[0]);
			e[i]=(x[N-1]*x[i-1]-x[0]*x[i])/(x[N-1]-x[0]);
			//set a random s[i] in (-1,1) 0,1/256,2/256,...255/256
			if (codes3[i]%2==0){
				s[i]=round((double)codes3[i]/2.3+5);//185.54;
			}
			else{
				s[i]=-round((double)codes3[i]/2.3+5);//-175.89;
			}
			c[i]=(y[i]-y[i-1])/(x[N-1]-x[0])-s[i]*(y[N-1]-y[0])/(x[N-1]-x[0]);
			f[i]=(x[N-1]*y[i-1]-x[0]*y[i])/(x[N-1]-x[0])-s[i]*(x[N-1]*y[0]-x[0]*y[N-1])/(x[N-1]-x[0]);
		}
		//initial_set
		write_file=fopen("temp_1.bin","wb+");
		fwrite(dbuffer,sizeof(double),N,write_file);
		fclose(write_file);
		free(dbuffer);
		//start mapping points through the IFS
		memcpy(read_name,"temp_1.bin",11);
		memcpy(write_name,"temp_2.bin",11);
		for (i=1;i<total_steps;i++){
			read_file=fopen(read_name,"rb+");
			write_file=fopen(write_name,"wb+");
			IFSR2_simple_map_points2D_with_files(read_file,write_file,a,e,s,c,f,N-1,S*(N-1),temp_mod);
			fclose(read_file);
			fclose(write_file);
			memcpy(temp_name,read_name,11);
			memcpy(read_name,write_name,11);
			memcpy(write_name,temp_name,11);
		}
		attr_file=fopen(read_name,"rb+");
		fseek(attr_file,0,SEEK_END);
		fgetpos(attr_file,&filepos);
		//AN2=filepos/sizeof(double);
		AN2=round(pow(N-1,total_steps)+1);
		fseek(attr_file,0,SEEK_SET); 
		
		read_file=fopen(fread_name,"rb+");
		write_file=fopen(fwrite_name,"wb+");
		pos=0;
		while (pos<AN2){
			dbuffer=(double*)malloc(POINTS_BUFFER*sizeof(double));
			items_read=fread(dbuffer,sizeof(double),POINTS_BUFFER,attr_file);
			buffer=(uint1*)malloc(POINTS_BUFFER);
			items_read=fread(buffer,sizeof(uint1),POINTS_BUFFER,read_file);
			for (i=1;i<=items_read;i++){
				int_temp=round(fmod(dbuffer[i-1],256));
				buffer[i-1]=buffer[i-1]^int_temp;
			}
			fwrite(buffer,sizeof(uint1),items_read,write_file);
			pos+=items_read;
			free(buffer);
			free(dbuffer);
		}
		flushall();
		fclose(read_file);
		fclose(write_file);
		fclose(attr_file);
		memcpy(temp_name,fread_name,11);
		memcpy(fread_name,fwrite_name,11);
		memcpy(fwrite_name,temp_name,11);
	}
}




//This code impements the Modulus Deterministic Algorithm for HVFIF
//for constructing Pseudo random numbers.
//It stores the numbers produced in each iteration to files
//as described in the paper. Be carefull with the usage of the hard disk.
//Make sure there is enough space.

//codes: a buffer (N bytes) consisting of the numbers of the seed.
//N: the number of numbers of the seed. (<MAX_CODES)
//points: the number of random numbers that the user wants to create
//bit_stream: a FILE. The function writes in that file
//the bits (as text characters) of the random numbers.
//the respective code (at the end) is not enabled.
//If one wants to test the random numbers with the NIST test program
//must enable this code.
//byte_stream: a FILE. The function writes in that file the 
//random numbers (as bytes). The file may be used 
//with the ENT or the Diehard test. 
void	SIMPLE_NON_CONV_MANY_HVIFS_PRNG_BIT_GEN_USING_FILES(uint4 *codes, uint2 N,
					uint4	points,
					FILE	*bit_stream,
					FILE	*byte_stream)
{
	uint4	i,j,k; 
	uint4	S=0,pos,apos,pos3;
	double	S1;
	uint4	N1;
	double	x[MAX_CODES],y1[MAX_CODES],y2[MAX_CODES],a[MAX_CODES],e[MAX_CODES],
				s11[MAX_CODES],s12[MAX_CODES],s21[MAX_CODES],s22[MAX_CODES],
				b[MAX_CODES],c[MAX_CODES],d[MAX_CODES],f[MAX_CODES],P,temp_double;
	for (i=1;i<=N;i++)
		S+=codes[i];
	codes[0]=codes[N];
	
	BYTE	byte;
	double	Ncodes[MAX_CODES],Ncodes2[MAX_CODES];
	uint4	index;
	double	psi,ni,mi_i,si,line_psi;
	uint4	x1,x2,start,xi,ip_pos,cf_pos;
	uint4	codes2[MAX_CODES];
	uint4	codes3[MAX_CODES];
	Points<double>	*mapped_attractor;
	Points<double>	*indeces_attractor;
	Points<double>	*temp_attractor;
	FILE	*debug_file;
	uint1	attractor_value,temp_uint1;
	double	temp,temp2,MO; 
	double	temp_x;
	FILE	*read_file,*write_file,*attr_file;
	char	read_name[11],write_name[11],fread_name[11],fwrite_name[11],temp_name[11];
	__int64	filepos;
	uint1	int_temp;
	uint1	*buffer;
	double	*dbuffer;
	uint4	items_read;
	uint1	total_steps;

	//initialise files
	write_file=fopen("temp_1.bin","wb+");
	fclose(write_file);
	write_file=fopen("temp_2.bin","wb+");
	fclose(write_file);
	write_file=fopen("bytes.bin","wb+");
	fclose(write_file);
	write_file=fopen("final1.bin","wb+");
	fclose(write_file);
	write_file=fopen("final2.bin","wb+");
	fclose(write_file);

	pos=0;//position index of the original stream.
	ip_pos=0;
	cf_pos=0;
	total_steps=floor(log(points/2-1)/log(N-1));
	uint4 AN2=pow(N-1,total_steps)+1;
	


 
	AN2=2*round(pow(N-1.0,total_steps)+1.0);
	memcpy(fread_name,"bytes.bin",11);
	memcpy(fwrite_name,"final2.bin",11);

	//initialise the file with AN2 0's
	write_file=fopen(fread_name,"wb+");
	pos=0;
	while (pos+POINTS_BUFFER<AN2){
		buffer=(uint1*)malloc(sizeof(uint1)*POINTS_BUFFER);
		for(i=0;i<POINTS_BUFFER;i++)
			buffer[i]=0;
		fwrite(buffer,sizeof(uint1),POINTS_BUFFER,write_file);
		pos+=POINTS_BUFFER;
		free(buffer);
	}
	buffer=(uint1*)malloc(sizeof(uint1)*(AN2%POINTS_BUFFER));
	for(i=0;i<AN2%POINTS_BUFFER;i++)
		buffer[i]=0;
	fwrite(buffer,sizeof(uint1),AN2%POINTS_BUFFER,write_file);
	free(buffer);
	fclose(write_file);


	uint2	M=5;
	uint4	thesis=0;
	double		temp_mod=pow(256,M);

	//for the mappings of the IFS
	for (i=1;i<=2*N;i++)
		codes3[i]=codes[i];
	//for the contraction factors and the initial set
	for (i=1;i<=2*N;i++){
		codes2[i]=codes[i];
		codes2[2*N+i]=codes[i];
	}
		 
	for (k=1;k<=8;k++){
		mult2(codes,M,Ncodes,2*N,k);//for the mappings
		mult2(codes2,M,Ncodes2,2*N,k);//for the initial set
		MO=fabs(Ncodes[1]);
		for(j=1;j<=2*N;j++){
			if (fabs(Ncodes[j])>MO)
				MO=fabs(Ncodes[j]);
		}
		temp_mod=floor(MO*1.2);
		S=0;
		for (i=1;i<=2*N;i++)
			S+=codes[i];
		//create the attractor of indeces!
		//The N interpolation points are
		//x=0, S, 2S, 3S, ... , (N-1)S
		//y=Ncodes[1], Ncodes[2], Ncodes[N]
		dbuffer=(double*)malloc(sizeof(double)*N*2);
		x[0]=0;
		for (j=1;j<=N;j++){
			y1[j-1]=Ncodes[2*j-1];
			y2[j-1]=Ncodes[2*j];
			dbuffer[2*j-2]=(Ncodes[2*j-1]);
			dbuffer[2*j-1]=(Ncodes[2*j]);
			x[j]=x[j-1]+S;
		} 
		//then define the mappings (N-1)
		for (i=1;i<=N-1;i++){
			a[i]=(x[i]-x[i-1])/(x[N-1]-x[0]);
			b[i]=x[i-1]-a[i]*x[0];
			//set a random s[i] in (-1,1) 0,1/256,2/256,...255/256
			if (codes2[i]%2==0){
				s11[i]=(double)codes2[i]/2.3+5;
			}
			else{
				s11[i]=-(double)codes2[i]/2.3+5;
			}
			if (codes2[N+i]%2==0){
				s12[i]=(double)codes2[N+i]/2.3+5;
			}
			else{
				s12[i]=-(double)codes2[N+i]/2.3+5;
			}
			if (codes2[2*N+i]%2==0){
				s21[i]=(double)codes2[2*N+i]/2.3+5;
			}
			else{
				s21[i]=-(double)codes2[2*N+i]/2.3+5;
			}
			if (codes2[3*N+i]%2==0){
				s22[i]=(double)codes2[3*N+i]/2.3+5;
			}
			else{
				s22[i]=-(double)codes2[3*N+i]/2.3+5;
			}
			c[i]=(y1[i]-y1[i-1])/(x[N-1]-x[0])-s11[i]*(y1[N-1]-y1[0])/(x[N-1]-x[0])-s12[i]*(y2[N-1]-y2[0])/(x[N-1]-x[0]);
			e[i]=(y2[i]-y2[i-1])/(x[N-1]-x[0])-s11[i]*(y1[N-1]-y1[0])/(x[N-1]-x[0])-s12[i]*(y2[N-1]-y2[0])/(x[N-1]-x[0]);
			d[i]=y1[0]-c[i]*x[0]-s11[i]*y1[0]-s12[i]*y2[0];
			f[i]=y2[0]-e[i]*x[0]-s21[i]*y1[0]-s22[i]*y2[0];
		}
		//initial_set
		write_file=fopen("temp_1.bin","wb+");
		fwrite(dbuffer,sizeof(double),2*N,write_file);
		fclose(write_file);
		free(dbuffer);
		//start mapping points through the IFS
		memcpy(read_name,"temp_1.bin",11);
		memcpy(write_name,"temp_2.bin",11);
		for (i=1;i<total_steps;i++){
			read_file=fopen(read_name,"rb+");
			write_file=fopen(write_name,"wb+");
			HVIFSR2_simple_map_points2D_with_files(read_file,write_file,
							a,e,s11,s12,s21,s22,c,d,f,N-1,S*(N-1),temp_mod);
			fclose(read_file);
			fclose(write_file);
			memcpy(temp_name,read_name,11);
			memcpy(read_name,write_name,11);
			memcpy(write_name,temp_name,11);
		}
		attr_file=fopen(read_name,"rb+");
		fseek(attr_file,0,SEEK_END);
		fgetpos(attr_file,&filepos);
		AN2=2*round(pow(N-1,total_steps)+1);
		fseek(attr_file,0,SEEK_SET); 
		
		read_file=fopen(fread_name,"rb+");
		write_file=fopen(fwrite_name,"wb+");
		pos=0;
		while (pos<AN2){
			dbuffer=(double*)malloc(POINTS_BUFFER*sizeof(double));
			items_read=fread(dbuffer,sizeof(double),POINTS_BUFFER,attr_file);
			buffer=(uint1*)malloc(POINTS_BUFFER);
			items_read=fread(buffer,sizeof(uint1),POINTS_BUFFER,read_file);
			for (i=1;i<=items_read;i++){
				int_temp=fmod(dbuffer[i-1],256);
				buffer[i-1]=buffer[i-1]^int_temp;
			}
			fwrite(buffer,sizeof(uint1),items_read,write_file);
			pos+=items_read;
			free(buffer);
			free(dbuffer);
		}
		flushall();
		fclose(read_file);
		fclose(write_file);
		fclose(attr_file);
		memcpy(temp_name,fread_name,11);
		memcpy(fread_name,fwrite_name,11);
		memcpy(fwrite_name,temp_name,11);
	}
}





//multiplies k elements of the array A
//and produces a new array NA.
//As decribed in the paper thi is done so that a small variation of the seed
//will lead to great differences of the interpolation points.
//N: is the number of elements of array A and NA

void mult2(uint4	A[],uint1 k,double NA[],uint1 N,uint1 step)
{
	uint1	or_pos,pos,i,j;
	double	P,prosimo;

	or_pos=1;
	uint1	synt=0;
	for (i=1;i<=N;i++){
		P=0;
		pos=or_pos;
		prosimo=0;
		for (j=1;j<=k;j++){
			P=P*256+A[pos];
			prosimo+=A[pos];
			pos=pos+step;
			if (pos>N)
				pos=pos-N;
		}
		//one more bit 
		//P=P*2+A[pos]%2;
		NA[i]=P;//*pow(-1,prosimo);
		or_pos++;
		k+=synt;
		synt*=-1;
	}
}

uint1 write_uint1_buffer_to_file(uint1 *buffer, uint4 N, FILE *stream)
{
	int	resp=fwrite(buffer,sizeof(uint1),N,stream);
	if(resp==N)
		return 0;
	else 
		return 1;
}


//Y must be positive
double	myfmod(double X, double Y)
{
	if (X>=0)
		return fmod(X,Y);
	else
		return Y-fmod(X,Y);
}
